
-- /!\ Sur SRV01 : Il faut stopper le distribution cleanup job avant cette tape
-- les seules choses qui changent sont le nom de la publication et les serveurs

:SETVAR user "sa"
:SETVAR pass "Coucou123"
:SETVAR db "demo"
:SETVAR bkppath "\\SRV01\backup"
:SETVAR publicationname "demoPubMigration"           -- <= on est bien sur la publication de migration
:SETVAR publisher "SRV01"
:SETVAR distributor "SRV01"
:SETVAR distributiondb "distribution01"
:SETVAR subscriber "SRV03"
 
:CONNECT $(publisher) -U $(user) -P $(pass)
GO
USE [master]
GO
PRINT N'---- Backup database $(db) to $(bkppath) ----';
GO 
BACKUP DATABASE $(db)
TO disk ='$(bkppath)\$(db)_replicationMigration.bak'
WITH stats=5 , init
GO
 

USE [$(db)]
GO
EXEC sys.sp_addsubscription @publication = '$(publicationname)'
	, @subscriber = '$(subscriber)'
	, @destination_db = '$(db)'
	, @subscription_type = 'pull'
	, @sync_type = 'initialize with backup'
	, @article = 'all'
	, @update_mode = 'read only'
	, @subscriber_type = 0
	, @backupdevicetype= 'disk'
	, @backupdevicename = '$(bkppath)\$(db)_replicationMigration.bak'
GO
 
--on subscriber
:CONNECT $(subscriber) -U $(user) -P $(pass)
GO
USE [master]
GO
PRINT N'---- Restore database $(db) ----';
IF EXISTS(SELECT * FROM sys.databases where name = '$(db)')
BEGIN
	DROP DATABASE $(db)
END
GO
RESTORE DATABASE $(db) FROM DISK = '$(bkppath)\$(db)_replication.bak'
GO
PRINT N'---- Set replication options ----';
GO
IF DATABASEPROPERTYEX('$(db)', 'IsPublished')=1
    EXEC sp_replicationdboption
        @dbname = N'$(db)'
        , @optname = N'publish'
        , @value = N'false'
GO 

USE [$(db)]
EXEC sys.sp_addpullsubscription
        @publisher = '$(publisher)',
        @publication = '$(publicationname)',
        @publisher_db = '$(db)',
        @independent_agent = 'True',
        @subscription_type = 'pull',
        @description = '',
        @update_mode = 'read only',
        @immediate_sync = 0;

DECLARE @JobId binary(16)
EXEC sys.sp_addpullsubscription_agent
        @publisher = '$(publisher)',
        @publisher_db = '$(db)',
        @publication = '$(publicationname)',
        @distributor = '$(distributor)',
        @distributor_security_mode = 0,
        @distributor_login = 'sa',
        @distributor_password = 'Coucou123',
        @enabled_for_syncmgr = 'False',
        @frequency_type = 64,
        @frequency_interval = 0,
        @frequency_relative_interval = 0,
        @frequency_recurrence_factor = 0,
        @frequency_subday = 0,
        @frequency_subday_interval = 0,
        @active_start_time_of_day = 0,
        @active_end_time_of_day = 235959,
        @active_start_date = 20111109,
        @active_end_date = 99991231,
        @alt_snapshot_folder = '',
        @working_directory = '',
        @use_ftp = 'False',
        @job_login = null,
        @job_password = null,
        @publication_type = 0,
        @distribution_jobid=@JobId OUTPUT;


GO 
